#include <16F877a.h>
#use delay (clock=20000000)
#fuses HS,NOWDT,PUT,NOBROWNOUT,PROTECT,NOPUT,NOCPD

#define    renk0       PIN_E0
#define    renk1       PIN_E1
#define    renk2       PIN_E2

#define    art         PIN_A1
#define    azt         PIN_A4
#define    mod         PIN_A3

//#define    uyarlight   PIN_A5
#define    TONE_PIN    PIN_A2


//int deger;
int calsmode=3; 
int renk0val, renk1val, renk2val;
//int lightyon;
//int inttime;
 

#define SERVO_PIN  PIN_B0

// These pulse duration values are for a 20 MHz PIC oscillator 
// frequency and a Timer1 divisor of 8. 
#define PWM_PERIOD 12500L  // Gives 20ms PWM period (50 Hz) 
//#define PULSE_1MS    625L  // Gives 1ms high level pulse 
//#define PULSE_2MS   1250L  // Gives 2ms high level pulse 
#define PULSE_1MS    625L  // Gives 1ms high level pulse 
#define PULSE_2MS   1250L  // Gives 2ms high level pulse 

int16 pulse_high_duration; 
int8  pulse_done_flag; 

//----------------------------------- 
#int_ccp1 
void ccp1_isr(void) 
{ 
static int8 set_servo_pin_high = TRUE; 

// If servo pin low level pulse time is finished, 
// then do the high portion of the signal. 
if(set_servo_pin_high)  
  { 
   output_high(SERVO_PIN);      
   set_servo_pin_high = FALSE; 
   CCP_1 += pulse_high_duration;    
  } 
else  // If high portion of signal is done, do the low part. 
  { 
   output_low(SERVO_PIN);        
   set_servo_pin_high = TRUE; 
   CCP_1 += (PWM_PERIOD - pulse_high_duration);    
    
   pulse_done_flag = TRUE; 
  } 

} 

//-------------------------{}----------------------------
#INT_TIMER2 
void timer2_isr(){ 

//output_toggle(pin_b0);

//if(inttime--==0)output_toggle(pin_d0);

/*if( deger < renk0val) output_high(renk0);
else output_low(renk0);

if( deger < renk1val) output_high(renk1);
else output_low(renk1);

if( deger < renk2val) output_high(renk2);
else output_low(renk2);
      
deger++;
*/
}
//-------------------------{}----------------------------
void beep(int16 period){
output_high(TONE_PIN);
   while((period--) != 0)
   {
     
      delay_ms(1);

   }
output_low(TONE_PIN);
}
//-------------------------{}----------------------------

//-----------------------------------------
sirala(int sayi){
int sirali;
sirali=0b00000001;
   while(sayi>=25){
      sayi-=25;
      if(bit_test(sirali,7)!=1) sirali = sirali<<1;
   }
   return sirali;
}
//-----------------------------------------
void main() {

int duyarga, bekleme;
int16 i; 

setup_wdt(WDT_2304MS);
//SETUP_TIMER_1(T1_DISABLED );
setup_timer_2(T2_DIV_BY_1,6,8); 
enable_interrupts(INT_TIMER2); 

setup_adc(  ADC_CLOCK_INTERNAL  );
setup_ADC_ports( AN0 );
set_adc_channel(0);

setup_timer_1(T1_DIV_BY_8 | T1_INTERNAL); 
set_timer1(0); 
// Setup CCP to generate CCP1 interrupt when Timer1 
// matches the value in the CCP1 registers. 
setup_ccp1(CCP_COMPARE_INT); 
output_low(SERVO_PIN); 

// Initialize the variables and CCP1 to give a 1 ms servo pulse. 
pulse_high_duration = PULSE_1MS;  
CCP_1 = PWM_PERIOD - pulse_high_duration;  // Pulse Off time 

// This flag tells the main loop code (below) when it's OK 
// to change the pulse_high_duration variable. 
pulse_done_flag = FALSE; 

clear_interrupt(INT_CCP1); 
enable_interrupts(INT_CCP1); 
enable_interrupts(GLOBAL); 


duyarga=0b00000001;
bekleme=30;
i = PULSE_1MS;
  
  /*
while(1) 
  { 
  restart_wdt();   
   // Slowly increase the pulse from 1ms to 2ms. 
   for(i = PULSE_1MS; i < PULSE_2MS; i++) 
      { 
       while(!pulse_done_flag); // Wait until pulse is done 
      
       pulse_done_flag = FALSE; 
       disable_interrupts(GLOBAL); 
       pulse_high_duration = i;    
       enable_interrupts(GLOBAL); 
      } 
  } */

   
  
//-------------------------{ANA DNG BA}----------------------------
while ( TRUE) {
restart_wdt();   
output_c(duyarga);
beep(1);

delay_ms(bekleme);

duyarga=duyarga<<1;
if(bit_test(duyarga,7)==1) duyarga=0b00000001;

bekleme=read_adc()>>3;

i=PULSE_1MS+(int16)(8*bekleme);

while(!pulse_done_flag); // Wait until pulse is done 
      
pulse_done_flag = FALSE; 
disable_interrupts(GLOBAL); 
pulse_high_duration = i;    
enable_interrupts(GLOBAL); 


if( !input(art)) { 
   if(bekleme>0)bekleme--; 
   if(i>PULSE_1MS) i=i-12;
   
   while(!pulse_done_flag); // Wait until pulse is done 
      
       pulse_done_flag = FALSE; 
       disable_interrupts(GLOBAL); 
       pulse_high_duration = i;    
       enable_interrupts(GLOBAL); 
   
   //while(!input(art));
}
if( !input(azt)) { 
   if(bekleme<31)bekleme++; 
   if(i<PULSE_2MS) i=i+12;
   
   while(!pulse_done_flag); // Wait until pulse is done 
      
       pulse_done_flag = FALSE; 
       disable_interrupts(GLOBAL); 
       pulse_high_duration = i;    
       enable_interrupts(GLOBAL); 
   //while(!input(azt));
}
   
}
//-------------------------{ANA DNG SON}----------------------------



   renk0val = read_eeprom(0);
   if ( renk0val > 250 ) renk0val = 0;
   renk1val = read_eeprom(1);
   if ( renk1val > 250 ) renk1val = 0;
   renk2val = read_eeprom(2);
   if ( renk2val > 250 ) renk2val = 0;

   calsmode = read_eeprom(10);
   if ( calsmode > 250 ) calsmode = 0;




   
   output_b(sirala(renk0val));
   output_c(sirala(renk1val));
   output_d(sirala(renk2val));

//-------------------------{ANA DNG BA}----------------------------
while ( TRUE) {
restart_wdt();

if( input(mod) == 0) {

   beep(2);
   if( calsmode++ == 3) calsmode=0;
   write_eeprom(10,calsmode);
   while(input(mod)==0);
}


if( !input(art)) {

   switch (calsmode) {
   
      case 0: 
         if(renk0val <= 225) renk0val+=25;
         else renk0val=0;
         write_eeprom(0,renk0val);
         output_b(sirala(renk0val));
      break;   
      
      case 1: 
         if(renk1val <= 225) renk1val+=25;
         else renk1val=0;
         write_eeprom(1,renk1val);         
         output_c(sirala(renk1val));
      break;
      
      case 2: 
         if(renk2val <= 225) renk2val+=25;
         else renk2val=0;
         write_eeprom(2,renk2val);         
         output_d(sirala(renk2val));
      break;
      
      case 3: 
      break;        

   }
   beep(2);
   while(input(art)==0);
}

if( !input(azt)) {

   switch (calsmode) {
   
      case 0: 
         if(renk0val >= 25) renk0val-=25;
         else renk0val=250;
         write_eeprom(0,renk0val);         
         output_b(sirala(renk0val));
      break;   
      
      case 1: 
         if(renk1val >= 25) renk1val-=25;
         else renk1val=250;
         write_eeprom(1,renk1val);         
         output_c(sirala(renk1val));
      break;
      
      case 2: 
         if(renk2val >= 25) renk2val-=25;
         else renk2val=250;
         write_eeprom(2,renk2val);         
         output_d(sirala(renk2val));
      break;
      
      case 3: 
      break;        

   }
   beep(2);
   while(input(azt)==0);
}





}
//-------------------------{ANA DNG SON}----------------------------

}
/*



     switch (calsmode) {
         
         case 0: // ortam aydnlk, k snk, uyar  yanp sner 
         output_low(renk1);
         output_high(uyarlight);
         delay_ms(50);
         output_low(uyarlight);
         sleep();         
         break;     
         
         case 1: // ortam karanlk, k 3l flar yapar
         output_low(uyarlight);
         output_high(renk1);
         delay_ms(20);
         output_low(renk1);
         delay_ms(20);
         output_high(renk1);
         delay_ms(20);
         output_low(renk1);
         delay_ms(20);
         output_high(renk1);
         delay_ms(20);
         output_low(renk1);
         output_high(uyarlight);
         delay_ms(200);
         break;            

         case 2: // ortam karanlk, k flar yapar
         output_low(uyarlight);
         output_high(renk1);
         delay_ms(10);
         output_low(renk1);
         delay_ms(50);
         break;   

         case 3: // ortam karanlk, k yanyor, seviye 1
         lightval = 50;
         isikyak();
         if(flashtime--==0) {
            output_low(uyarlight);
            output_high(renk1);
            delay_ms(50);
            flashtime=20000;
         }
         break;
         
         case 4: // ortam karanlk, k yanyor, seviye 2
         lightval = 80;
         isikyak();
         if(flashtime--==0) {
            output_low(uyarlight);
            output_high(renk1);
            delay_ms(50);
            flashtime=20000;
         }
         break;
         
         case 5: // ortam karanlk, k yanyor, seviye 3
         lightval = 110;
         isikyak();
         if(flashtime--==0) {
            output_low(uyarlight);
            output_high(renk1);
            delay_ms(50);
            output_low(renk1);
            delay_ms(50);
            output_high(renk1);
            delay_ms(50);
            flashtime=20000;
         }
         break;
         
         case 6: // ortam karanlk, k yanyor, seviye 4
         lightval = 140;
         isikyak();
         break;
         
         case 7: // ortam karanlk, k yanyor, seviye 5
         lightval = 170;
         isikyak();
         break;
         
         case 8: // ortam karanlk, k yanyor, seviye 6
         lightval = 200;
         isikyak();
         break;
      
         case 9: // Yumuak geili 
         output_low(uyarlight);
         if(fadeintimer-- == 0) lightval=lightval+lightyon;
         if( lightval==10 ) lightyon= +1;
         if( lightval==200) lightyon= -1;
         isikyak();
         break;       
      
      
         default: 
         break;
     }
  
   

}

}*/
